package com.steerinfo.pretrack.peraddweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.peraddweight.model.PerAddWeight;
import com.steerinfo.pretrack.peraddweight.service.IPerAddWeightService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * PerAddWeight RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-12-04 08:33
 * 类描述
 * 修订历史：
 * 日期：2020-12-04
 * 作者：generator
 * 参考：
 * 描述：PerAddWeight RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/peraddweights")
public class PerAddWeightController extends BaseRESTfulController {

    @Autowired
    IPerAddWeightService perAddWeightService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("peraddweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PerAddWeight> list = perAddWeightService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("peraddweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PerAddWeight> list = perAddWeightService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据PerAddWeight对象创建")
    @ApiImplicitParam(name = "perAddWeight", value = "详细实体perAddWeight", required = true, dataType = "PerAddWeight")
    //@RequiresPermissions("peraddweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PerAddWeight model) {
        try {
            PerAddWeight perAddWeight = perAddWeightService.add(model);
            return success(perAddWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("peraddweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            PerAddWeight perAddWeight = perAddWeightService.getById(id);
            return success(perAddWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的perAddWeight信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "perAddWeight", value = "详细实体perAddWeight", required = true, dataType = "PerAddWeight")
    })
    //@RequiresPermissions("peraddweight:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PerAddWeight model) {
        try {
            model.setId(id);
            PerAddWeight perAddWeight = perAddWeightService.modify(model);
            return success(perAddWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("peraddweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                perAddWeightService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    //以下为自己的代码
    @ApiOperation(value = "创建", notes = "根据PerAddWeight对象创建")
    @ApiImplicitParam(name = "perAddWeight", value = "详细实体perAddWeight", required = true, dataType = "PerAddWeight")
    @PostMapping(value = "/checkAndAdd")
    public RESTfulResult checkAndAdd(@RequestBody PerAddWeight model) {
        RESTfulResult rm = failed();
        try {
            String no = perAddWeightService.checkAndAdd(model);
            if (no != null) {
                return success(no);
            } else {
                return failed("新增失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "删除", notes = "根据PerAddWeight对象创建")
    @ApiImplicitParam(name = "perAddWeight", value = "详细实体perAddWeight", required = true, dataType = "PerAddWeight")
    @PostMapping(value = "/delete")
    public RESTfulResult checkAndDelete(@RequestBody List<PerAddWeight> models) {
        RESTfulResult rm = failed();
        try {
            int num = perAddWeightService.checkAndDelete(models);
            if (num > 0) {
                return success(num);
            } else {
                return failed("新增失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
